package jalview.api.analysis;

import java.util.ArrayList;
import java.util.List;

public class AnnotationFilterParameter
{
  public enum ThresholdType
  {
    NO_THRESHOLD, BELOW_THRESHOLD, ABOVE_THRESHOLD;
  }

  public enum SearchableAnnotationField
  {
    DISPLAY_STRING, DESCRIPTION;
  }
  private ThresholdType thresholdType;

  private float thresholdValue;

  private boolean filterAlphaHelix = false;

  private boolean filterBetaSheet = false;

  private boolean filterTurn = false;

  private String regexString;

  private List<SearchableAnnotationField> regexSearchFields = new ArrayList<SearchableAnnotationField>();

  public ThresholdType getThresholdType()
  {
    return thresholdType;
  }

  public void setThresholdType(ThresholdType thresholdType)
  {
    this.thresholdType = thresholdType;
  }

  public float getThresholdValue()
  {
    return thresholdValue;
  }

  public void setThresholdValue(float thresholdValue)
  {
    this.thresholdValue = thresholdValue;
  }

  public String getRegexString()
  {
    return regexString;
  }

  public void setRegexString(String regexString)
  {
    this.regexString = regexString;
  }

  public List<SearchableAnnotationField> getRegexSearchFields()
  {
    return regexSearchFields;
  }

  public void addRegexSearchField(SearchableAnnotationField regexSearchField)
  {
    this.regexSearchFields.add(regexSearchField);
  }

  public boolean isFilterAlphaHelix()
  {
    return filterAlphaHelix;
  }

  public void setFilterAlphaHelix(boolean alphaHelix)
  {
    this.filterAlphaHelix = alphaHelix;
  }

  public boolean isFilterBetaSheet()
  {
    return filterBetaSheet;
  }

  public void setFilterBetaSheet(boolean betaSheet)
  {
    this.filterBetaSheet = betaSheet;
  }

  public boolean isFilterTurn()
  {
    return filterTurn;
  }

  public void setFilterTurn(boolean turn)
  {
    this.filterTurn = turn;
  }

}
